// pageage/safetyManagement/addSafetyInspect/index.js
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        maxDate:new Date(2088,1,1).getTime(),
        currentDate:new Date().getTime(),
        deptId:"",
        projectId:"",
        projectName:"",
        loginName:"",
        userName:"",
        rectifierData:[],
        rectifierData2:[],
        imageInfoData:[],
        checkingResult:"1",
        //验收时间
        checkTime:'',
        loadShow:false,
        qualityUser:"",
        qualityUserName:"",
        superviseUser:"",
        superviseUserName:"",
        checkWorkingPosition:"",
        intro:"",
        list:[{id:1,text:"合格"},{id:2,text:"不合格"}]
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {projectId,projectName} = options
        //获取缓存数据
        wx.getStorage({
        key: 'userinfo',
        success:res=>{
            this.setData({
            projectId,
            projectName,
            deptId:res.data.deptId,
            loginName:res.data.loginName,
            userName:res.data.nickName
            }) 
            this.getProjectUserData()
        }  
        }) 
    },

    //查询项目人员数据
    getProjectUserData(){
        let that = this
        wx.request({
            url: app.globalData.reqUrl+'/wechat/projectuserinfo/selectProjectUnitUser',
            method:"get",
            data:{
                unitType:"4",
                projectId:that.data.projectId
            },
            header:{
              'content-type': 'application/x-www-form-urlencoded'  
            },
            success(res){
                res = res.data
                if(res.code == 200){
                    let tempData = []
                    that.setData({
                        rectifierData:res.data,
                    })
                }
            }
        })

        wx.request({
            url: app.globalData.reqUrl+'/wechat/projectuserinfo/selectProjectUnitUser',
            method:"get",
            data:{
                unitType:"2",
                projectId:that.data.projectId
            },
            header:{
              'content-type': 'application/x-www-form-urlencoded'  
            },
            success(res){
                res = res.data
                if(res.code == 200){
                    let tempData = []
                    that.setData({
                        rectifierData2:res.data,
                    })
                }
            }
        })
    },

    //切换验收结果
    onSelectType(e){
        this.setData({
            checkingResult:e.detail.id
        })
      },

    //工序部位
    onInputCheckWorkingPositionValue(e){
        let checkWorkingPosition = e.detail.value
        this.setData({
            checkWorkingPosition
        })
    },
    //验收描述
    onInputIntroValue(e){
        let intro = e.detail.value
        this.setData({
            intro
        })
    },

    //验收时间
    onInputTime(e){
        let checkTime = e.detail
        this.setData({
            checkTime
        })
    },

    // list  上传图片
    onImagesArr(e){
        var data = this.data.imageInfoData
        data = e.detail
        this.setData({
            imageInfoData:data
        })
    },

    //添加质量专员
    onAddQualityUser(e){
        if(e.detail.length>0){
            this.setData({
                qualityUser:e.detail[0].phoneNumber,
                qualityUserName:e.detail[0].userName
            })
        }
    },

    //添加监理专员
    onAddSuperviseUser(e){
        if(e.detail.length>0){
            this.setData({
                superviseUser:e.detail[0].phoneNumber,
                superviseUserName:e.detail[0].userName
            })
        }
    },

    //取消页面
    cancelSaveView(){
        this.returnToPage()
    },

    //保存
    onProblemSubmitSave(){
        this.setData({
            loadShow:true
        })
        let that = this
        let {projectId,deptId,qualityUser,qualityUserName,superviseUser,superviseUserName,checkWorkingPosition,intro,checkTime,checkingResult,imageInfoData,loginName,userName} =  that.data;
        //数据效验
        if(projectId==""||deptId==""||loginName==""){
            app.toast("数据异常，请刷新页面重试!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(imageInfoData.length==0){
            app.toast("请上传举牌验收现场图片!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(qualityUser==""||qualityUserName==""){
            app.toast("请选择质量专员!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(superviseUser==""||superviseUserName==""){
            app.toast("请选择监理专员!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(checkWorkingPosition==""){
            app.toast("请填写验收工序部位!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(intro==""){
            app.toast("请填写验收结果描述!")
            that.setData({
                loadShow:false
            })
            return;
        }
        if(checkTime==""){
            app.toast("请选择验收时间!")
            that.setData({
                loadShow:false
            })
            return;
        }
        // if(checkingResult==""){
        //     app.toast("请选择验收结果!")
        //     that.setData({
        //         loadShow:false
        //     })
        //     return;
        // }
        
        let fileUrls = [];
        imageInfoData.forEach(async (item)=>{
            let uploadUrl = app.globalData.uploadUrl+'/common/upload'
            let name = "file" 
            //这里复杂的图片上传，改为同步上传，因为小程序只能上传一张图片
            let obj = await that.syncUploadImage(uploadUrl,item,name);
            fileUrls.push(obj.data.fileName);
            //验证图片上传完毕
            if(fileUrls.length == imageInfoData.length){
                let params = {
                    projectId,
                    deptId:deptId,
                    qualityUser,
                    qualityUserName,
                    superviseUser,
                    superviseUserName,
                    checkWorkingPosition,
                    intro,
                    checkingDate:checkTime,
                    //checkResult:checkingResult,
                    approveStatus:"1",
                    createBy:loginName,
                    imageUrls:fileUrls.toString()
                }
                wx.request({
                    url: app.globalData.reqUrl + '/wechat/projectchecking/add',
                    method:"POST",
                    data:params,
                    header: {
                        "Username": loginName,
                        "Content-Type": "application/json"
                    },
                    success(res){
                        that.setData({
                            loadShow:false
                        })
                        res =res.data
                        if(res.code == 200){
                            app.toast("添加成功!")
                            setTimeout(()=>{
                            wx.redirectTo({
                                url: '../list/index',
                            })
                            },200)
                        }
                    }
                    })
                }
            })
    },

    /**
     * 这里考虑上传图片异步问题，封装为同步
     */
    syncUploadImage(url,uploadFile,name) {
        return new Promise((resolve, reject) => {
            wx.uploadFile({
            url, // 上传的服务器接口地址
            filePath: uploadFile,
            header: {
                "Content-Type": "application/x-www-form-urlencoded;charset=UTF-8"      
            },
            name, //上传的所需字段，后端提供
            formData: { user: 'test' },
            success: (res) => {
                // 上传完成操作
                const data = JSON.parse(res.data)
                resolve({
                    data: data
                })
            },
            fail: (err) => {
                //上传失败：修改pedding为reject
                console.log("访问接口失败", err);
                wx.showToast({
                title: "网络出错,上传失败",
                icon: 'none',
                duration: 1000
                });
                reject(err)
            }
            });
        })
    },

    returnToPage: function () {
        /*关闭当前页面，跳转到应用内的某个页面。但是不允许跳转到 tabbar 页面*/
        wx.redirectTo({
            url: '../list/index',
        })
      },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})